#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

#include "expressoes.h"
#include "pilha.h"
#include "atomos.h"

struct ArvExpr {
   Atomo* atomo;
   ArvExpr* esq;
   ArvExpr* dir;
};

/* -------------------------------------------------- */
/* Inclua as funes auxiliares que achar necessrio. */
/* -------------------------------------------------- */


/* Converte a cadeia apontada por `inf em notao infixa para a
 * cadeia aponta por `posf em notao posfixa. Cada um dos atomos
 * deve vir separado por espao, a cadeia deve ser terminada com '\0'.
 * Para facilitar, pode usar o separador de tomos para ler os tomos
 * da cadeia infixa.
 */
void ConverteInPos(char *inf, char *posf) {
   /* COMPLETAR */
   return;
}


/* Cria um n da rvore de expresses, com filhos `esq e `dir.
 */
ArvExpr* ArvExprCriaNo(ArvExpr* esq, ArvExpr* dir) {
   /* COMPLETAR */
   return NULL; /* PROVISRIO */
}

/* Cria uma rvore de expresses a partir de uma expresso em notao
 * posfixa, dada na cadeia `posf. Para facilitar, pode usar o
 * separador de tomos para ler os tomos da cadeia posfixa.
 */
ArvExpr* ArvExprDeExprPosfixa(char *posf) {
   /* COMPLETAR */
   return NULL; /* PROVISRIO */
}


/* Funo auxiliar para ArvExprLiberaAux
 */
void ArvExprLiberaAux(ArvExpr *a) {
   /* COMPLETAR */
}

/* Libera toda a memria alocada pela rvore a. Faz *a igual a NULL no final.
 */
void ArvExprLibera(ArvExpr **a) {
   ArvExprLiberaAux(*a);
   *a=NULL;
}


/* Funo auxiliar para ArvExprImprime.
 */
void ArvExprImprimeAux(ArvExpr* a, int level) {
   /* COMPLETAR */
}


/* Imprime a rvore de expresses apontada por `a na horizontal.
 * Por exemplo, a seguinte rvore:
 *       *
 *     /   \
 *    +     f
 *  /   \
 * a     *
 *     /   \
 *    *     +
 *   / \   / \
 *  b   c d   e
 * Representando a expresso (a+(b*c)*(d+e))*f seria impressa como:
 *       a
 *    +
 *             b
 *          *
 *             c
 *       *
 *             d
 *          +
 *             e
 * *
 *    f
 * 
 * Note que 3 espaos separam um nvel pai de um nvel filho.
 * Implemente apenas a funo auxiliar.
 */
void ArvExprImprime(ArvExpr* a) {
   ArvExprImprimeAux(a, 0);
}

/* Funo auxiliar. Pode ser til para indicar se  necessrio usar
 * parnteses na notao infixa.
 */
boolean PrecisaParenteses(Atomo *pai, Atomo *filho) {
   /* COMPLETAR */
   return true; /* PROVISRIO */
}

/* Funo auxiliar para ArvExprImprimeInfixa.
 */
void ArvExprImprimeInfixaAux(ArvExpr* a) {
   /* COMPLETAR */
}

/* Imprime a expresso representada pela rvore `a, usando a notao
 * infixa e com o nmero mnimo de parnteses necessrio.
 */
void ArvExprImprimeInfixa(ArvExpr* a) {
   ArvExprImprimeInfixaAux(a);
   printf("\n");
}


/* Funo auxiliar para ArvExprImprimePosfixa.
 */
void ArvExprImprimePosfixaAux(ArvExpr* a) {
   /* COMPLETAR */
}

/* Imprime a expresso representada pela rvore `a, usando a notao
 * posfixa.
 */
void ArvExprImprimePosfixa(ArvExpr* a) {
   ArvExprImprimePosfixaAux(a);
   printf("\n");
}

/* Funo auxiliar para ArvExprImprimePosfixa.
 */
void ArvExprImprimePrefixaAux(ArvExpr* a) {
   /* COMPLETAR */
}

/* Imprime a expresso representada pela rvore `a, usando a notao
 * prefixa.
 */
void ArvExprImprimePrefixa(ArvExpr* a) {
   ArvExprImprimePrefixaAux(a);
   printf("\n");
}

/* Avalia uma expresso representada por uma rvore de
 * expresso. Atribuindo valores s variveis passadas como parmetro
 * no vetor vars. O nmero de variveis passadas est no vetor
 * nvars. Caso exista alguma varivel na rvore de expresses que no
 * esteja no vetor vars, o valor da varivel deve ser considerado
 * zero. O resultado  sempre um double. Se a rvore for vazia, o
 * valor da expresso  zero.
 */
double ArvExprAvalia(ArvExpr* a, VarValor vars[], int nvars) {
   /* COMPLETAR */
   return 0.0;
}
