/*
 * OBS: as linhas entre #ifndef ... #endif devem ser as primeiras
 * linhas da funo. No as altere ou remova em hiptese alguma.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hash.h"
#ifndef NOGAB
#include "hash_gab.h"
#endif

Funcoes funcao_testada;


/* Calcula a funo de espalhamento. O resultado deve ser entre 0 e TAMHASH-1.
 */
unsigned int Hash(char *nome) {
#ifndef NOGAB
   if ( funcao_testada != f_Hash ) return Hash_gab(nome);
#endif
   /* COMPLETAR A PARTIR DAQUI */

   return 0; /* Provisrio */
}

/* Devolve apontador para uma tabela de hash vazia e inicializada.
 */
TabelaHash* CriaTabela() {
#ifndef NOGAB
   if ( funcao_testada != f_CriaTabela ) return CriaTabela_gab();
#endif
   /* COMPLETAR A PARTIR DAQUI */

   return NULL; /* Provisrio */
}

/* Insere um aluno `a na tabela `t. Se j existir um aluno com o
 * mesmo `nome, devolve false, caso contrrio true.
 */
boolean InsereTabela(TabelaHash* t, Aluno *a) {
#ifndef NOGAB
   if ( funcao_testada != f_InsereTabela ) return InsereTabela_gab(t,a);
#endif
   /* COMPLETAR A PARTIR DAQUI */

   return false; /* Provisrio */
}

/* Remove da tabela `t o aluno com nome `nome, e devolve true.
 * Se no existir, devolve false. 
 */
boolean RemoveTabela(TabelaHash* t, char *nome) {
#ifndef NOGAB
   if ( funcao_testada != f_RemoveTabela ) return RemoveTabela_gab(t,nome);
#endif
   /* COMPLETAR A PARTIR DAQUI */

   return false; /* Provisrio */
}

/* Busca por um aluno com nome `nome, e se encontrado, devolve true e
 * o aluno na varivel `a. Se no for encontrado, devolve false.
 */
boolean ConsultaTabela(TabelaHash *t, char *nome, Aluno *a) {
#ifndef NOGAB
   if (funcao_testada != f_ConsultaTabela) return ConsultaTabela_gab(t,nome,a);
#endif
   /* COMPLETAR A PARTIR DAQUI */

   return false; /* Provisrio */
}

/* Nmero de alunos atualmente na tabela `t.
 */
int NumeroAlunosTabela(TabelaHash *t) {
#ifndef NOGAB
   if (funcao_testada!=f_NumeroAlunosTabela) return NumeroAlunosTabela_gab(t);
#endif
   /* COMPLETAR A PARTIR DAQUI */

   return 0; /* Provisrio */
}

/* Imprime os alunos da tabela `t, um por linha, na ordem das
 * entradas na tabela, e para cada uma, na ordem da lista ligada.
 * Veja o arquivo de sada para detalhes do formato.
 */
void ImprimeTabela(TabelaHash *t) {
#ifndef NOGAB
   if ( funcao_testada != f_ImprimeTabela ){ImprimeTabela_gab(t); return;}
#endif
   /* COMPLETAR A PARTIR DAQUI */

   return;
}

/* Libera toda a memria usada pela tabela de espalhamento `t,
 * inclusive as cadeias que guardam os nomes.
 */
void LiberaTabela(TabelaHash *t) {
#ifndef NOGAB
   if ( funcao_testada != f_LiberaTabela ){LiberaTabela_gab(t);return;}
#endif
   /* COMPLETAR A PARTIR DAQUI */

   return;
}
