#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include "pagina.h"

extern Funcoes funcao_testada;

void lelinha() {
   int c;
   do { c=getchar(); } while (c!='\n');
}

int main(int argc, char *argv[]) {
   /* ----------------------------------------------------------------------
      Declaraes e incio para verificao do uso da memria dinmica.
      ---------------------------------------------------------------------- */
   struct mallinfo info = mallinfo();
   int MemDinInicial = info.uordblks, MemDinFinal;
   /* ---------------------------------------------------------------------- */

   char fun[255]; scanf("%s", fun);
   if ( strcmp(fun,"InserePagina") == 0 ) {
      funcao_testada = f_InserePagina;
   } else if ( strcmp(fun,"InsereLink") == 0 ) {
      funcao_testada = f_InsereLink;
   } else if ( strcmp(fun,"DestroiGrafo") == 0 ) {
      funcao_testada = f_DestroiGrafo;
   } else if ( strcmp(fun,"BuscaPaginaMaisPopular") == 0 ) {
      funcao_testada = f_BuscaPaginaMaisPopular;
   } else if ( strcmp(fun,"ExisteCiclo") == 0 ) {
      funcao_testada = f_ExisteCiclo;
   } else if ( strcmp(fun,"ImprimePaginasAlcancaveis") == 0 ) {
      funcao_testada = f_ImprimePaginasAlcancaveis;
   } else if ( strcmp(fun,"BuscaCaminhoMinimo") == 0 ) {
      funcao_testada = f_BuscaCaminhoMinimo;
   } else {
      printf("Funo `%s a ser testada  desconhecida.\n", fun);
      return 2;
   }
   printf("Testando apenas a funo `%s.\n", fun);


   char url1[255], url2[255], comando[255];
   Grafo *grafo;
   int val, val2, val3;

   scanf("%d", &val);
   grafo = CriaGrafo(val);

   for (int i = 0; i < val; i++) {
     scanf("%s %d", url1, &val2);
     if (!InserePagina(grafo, i, url1)) {
       printf("### Erro ao inserir pagina %s com indice %d ###\n", url1, i);
     }
     for (int j = 0; j < val2; j++) {
       scanf("%d", &val3);
       if (!InsereLink(grafo, i, val3)) {
	 printf("### Erro ao inserir link para a pagina %d na pagina %d ###\n",
		val3, i);
       }
     }
   }

   while ( scanf("%s", comando) > 0 ) {
     if ( strcmp(comando, "imprime") == 0 ) {

       ImprimeGrafo(grafo);

     } else  if ( strcmp(comando, "libera") == 0 ) {

       DestroiGrafo(&grafo);

     } else if ( strcmp(comando, "paginamaispopular") == 0 ) {

       char *url = BuscaPaginaMaisPopular(grafo, &val);
       printf("Pgina mais popular: %s com %d link(s)\n", url, val);

     } else if ( strcmp(comando, "existeciclo") == 0 ) {

       if (ExisteCiclo(grafo))
	 printf("O grafo possui ciclo(s).\n");
       else
	 printf("O grafo no possui ciclo(s).\n");

     } else if ( strcmp(comando, "imprimealcancaveis") == 0 ) {

       scanf("%s", url1);
       ImprimePaginasAlcancaveis(grafo, url1);

     } else if ( strcmp(comando, "caminhominimo") == 0 ) {

       scanf("%s %s", url1, url2);
       val = BuscaCaminhoMinimo(grafo, url1, url2);
       if (val == -1) {
	 printf("### No existe caminho de %s para %s ###\n", url1, url2);
       } else {
	 printf("Menor caminho entre %s e %s: %d link(s)\n", url1, url2, val);
       }

     } else if ( strcmp(comando, "sair") == 0 ) {

       break;

     } else {

       printf("Comando desconhecido: `%s\n", comando);

     }
   }

   /* --------------------------------------------------------------------- */
   /* Verificao final do uso da memria dinmica                          */
   /* --------------------------------------------------------------------- */
   info = mallinfo();
   MemDinFinal = info.uordblks;
   if (MemDinInicial!=MemDinFinal)
      printf("\n\nMemria dinmica no foi totalmente liberada (%d, %d)\n",
	     MemDinInicial,MemDinFinal);
   /* --------------------------------------------------------------------- */
   return 0;
}
