#ifndef ATOMOS_H
#define ATOMOS_H

/* Tipo dos tomos encontrados em uma expresso algbrica.
 */
typedef enum {
   operador, variavel, constante, parenteses
} tipo_at;

/* Tipo tomo. Que compe as expresses e ns da rvore de expresses.
 * Note que parnteses no deve ser representado na rvore de
 * expresses e s deve ocorrer em notao infixa.
 */
typedef struct Atomo {
   tipo_at tipo;
   union {
      double cte;
      char var;
      char op;
      char par;
   } val;
} Atomo;

/* Estrutura que armazena o estado do separador de tomos.
 */
typedef struct SeparadorEstado {
   int pos;
   char *str;
} SeparadorEstado;

/* Inicializa o estado do separador. Preparando-o para varrer a cadeia str.
 */
void SeparadorInicializa(SeparadorEstado *t, char *str);

/* Retorna o prximo tomo da cadeia. O tomo  alocado dinamicamente
 * e deve ser desalocado em algum momento.
 */
Atomo* SeparadorProxAtomo(SeparadorEstado *t);

/* Imprime um tomo.
 */
void ImprimeAtomo(Atomo *);


/* 
 * Exemplo de uso do separador. Essa funo no ser usada para nada,
 * encontra-se disponvel apenas para exemplificar o uso do separador.
 * Veja o arquivo atomos.c
 */
void ImprimeAtomosDeCadeia(char *cadeia);

#endif
