#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include "expressoes.h"

#define NARV 5

void lelinha() {
   int c;
   do { c=getchar(); } while (c!='\n');
}

int main() {
   /* ----------------------------------------------------------------------
      Declaraes e incio para verificao do uso da memria dinmica.
      ---------------------------------------------------------------------- */
   struct mallinfo info = mallinfo();
   int MemDinInicial = info.uordblks, MemDinFinal;
   /* ---------------------------------------------------------------------- */
   ArvExpr* arv[NARV] = {0};
   VarValor vv[100];
   int nvars = 0;
   char buf1[2*TAM_MAX_EXPR+2], buf2[2*TAM_MAX_EXPR+2], comando[100];
   char var;
   double val;
   int k;


   while ( scanf("%s", comando) > 0 ) {
      if ( strcmp(comando,"inpos") == 0 ) {

	 scanf(" %[^\n]", buf1); lelinha();
	 ConverteInPos(buf1, buf2);
	 printf("Posfixa: %s\n", buf2);

      } else if ( strcmp(comando, "arv") == 0 ) {

	 scanf("%d %[^\n]", &k, buf1); lelinha();
	 if ( k < 0 || k >= NARV) {
	    fprintf(stdout, "valor fora dos limites: %d\n", k);
	 } else {
	    arv[k] = ArvExprDeExprPosfixa(buf1);
	    printf("rvore de: %s\n", buf1);
	    ArvExprImprime(arv[k]);
	    //printf("\n");
	 }

      } else if ( strcmp(comando, "libera") == 0 ) {

	 scanf("%d", &k); lelinha();
	 if ( k < 0 || k >= NARV) {
	    fprintf(stdout, "valor fora dos limites: %d\n", k);
	 } else {
	    ArvExprLibera(&arv[k]);
	 }

      } else if ( strcmp(comando, "in") == 0 ) {

	 scanf("%d", &k); lelinha();
	 if ( k < 0 || k >= NARV) {
	    fprintf(stdout, "valor fora dos limites: %d\n", k);
	 } else {
	    printf("Infixa: "); ArvExprImprimeInfixa(arv[k]);
	 }

      } else if ( strcmp(comando, "pos") == 0 ) {

	 scanf("%d", &k); lelinha();
	 if ( k < 0 || k >= NARV) {
	    fprintf(stdout, "valor fora dos limites: %d\n", k);
	 } else {
	    printf("Posfixa: "); ArvExprImprimePosfixa(arv[k]);
	 }

      } else if ( strcmp(comando, "pre") == 0 ) {

	 scanf("%d", &k); lelinha();
	 if ( k < 0 || k >= NARV) {
	    fprintf(stdout, "valor fora dos limites: %d\n", k);
	 } else {
	    printf("Prefixa: "); ArvExprImprimePrefixa(arv[k]);
	 }

      } else if ( strcmp(comando, "avalia") == 0 ) {

	 scanf("%d", &k);
	 while ( getchar() != '\n' ) {
	    scanf("%c=%lf", &var, &val);
	    vv[nvars].var = var;
	    vv[nvars].valor = val;
	    nvars++;
	 }
	 if ( k < 0 || k >= NARV) {
	    fprintf(stdout, "valor fora dos limites: %d\n", k);
	 } else {
	    printf("Resultado: %.10g\n", ArvExprAvalia(arv[k], vv, nvars));
	    nvars = 0;
	 }
      } else if ( strcmp(comando, "sair") == 0 ) {
	 break;
      } else {
	 printf("Comando desconhecido: `%s\n", comando);
      }
   }


   /* --------------------------------------------------------------------- */
   /* Verificao final do uso da memria dinmica                          */
   /* --------------------------------------------------------------------- */
   info = mallinfo();
   MemDinFinal = info.uordblks;
   if (MemDinInicial!=MemDinFinal)
      printf("\n\nMemria dinmica no foi totalmente liberada (%d, %d)\n",
	     MemDinInicial,MemDinFinal);
   /* --------------------------------------------------------------------- */
   return 0;
}
