/* MC202 - Estruturas de dados - 2. semestre de 2005.
 * Funes para a montagem da rvore de codificao. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "arvhuff.h"
#include "heap.h"


/* Rotina auxiliar para comparao das freqncias das sub-rvores.
 * Retorna um valor menor que zero se arv1->freq < arv2->freq ou um
 * valor maior que zero se arv1->freq > arv2->freq.  Caso as
 * freqncias sejam iguais, retorna um valor menor do que zero caso
 * arv1 contenha um caracter de valor ASCII menor que arv2, ou
 * retorna um valor maior do que zero caso contrrio.
 *
 * J vem implementada e no deve ser modificada.
 */
int compara_no(No *arv1, No *arv2) {
  if (arv1->freq != arv2->freq)
    return arv1->freq - arv2->freq;
  return arv1->c - arv2->c;
}

/* Funo que cria um n vazio.
 *
 * J vem implementada e no deve ser modificada.
 */
No *cria_no_vazio() {
  No *no = (No*) malloc(sizeof(No));
  no->esq = no->dir = NULL;
  no->c = 0;
  no->freq = 0;
  return no;
}


/* Voc deve implementar todas as funes abaixo. Se necessrio,
 * voc pode criar funes auxiliares aqui. */


/* Retorna um vetor de tamanho N_CHARS com a freqncia dos caracteres do
 * arquivo fornecido. O ndice no vetor representa o valor ASCII de um
 * caracter. */
int *conta_frequencia_arquivo(FILE *arq) {
  return NULL; /* PROVISORIO */
}


/* Faz a unio de duas sub-rvores. O novo n deve conter o caracter de
 * menor valor ASCII e a soma das freqncias das sub-rvores. A sub-rvore
 * de menor freqncia deve ficar  esquerda. Em caso de empate, a rvore
 * com o caracter de menor valor ASCII deve ficar  esquerda. */
No *merge_no(No *arv1, No *arv2) {
  return NULL; /* PROVISORIO */
}


/* Gera a rvore a partir de um arquivo. */
No *gera_arvore_arquivo(char *nomearq) {
  return NULL; /* PROVISORIO */
}


/* Libera toda a memria ocupada pela rvore. */
void destroi_arvore(No *arv) {
  /* PROVISORIO */
}


/* Retorna um vetor de strings de tamanho N_CHARS com a codificao de
 * Huffman dos caracteres. O ndice no vetor representa o valor ASCII de
 * um caracter. Quando um caracter no possuir codificao, sua posio
 * no vetor deve conter NULL. arv aponta para a raiz da rvore. */
char **gera_tabela_arvore(No *arv) {
  return NULL; /* PROVISORIO */
}


/* Libera toda a memria ocupada pela tabela. */
void destroi_tabela(char **tabela) {
  /* PROVISORIO */
}


/* Imprime a tabela de codificao. A primeira linha deve ser o nmero de
 * codificaes. */
void imprime_tabela(char **tabela) {
  /* PROVISORIO */
}


/* Insere o caracter c com codificao codif na rvore apontada por arv. */
void insere_arvore(No *arv, unsigned char c, char *codif) {
  /* PROVISORIO */
}
