#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include "hash.h"

#define TAMMAXNOME 100

extern Funcoes funcao_testada;


void LeAluno(Aluno *a) {
   char buf[TAMMAXNOME];
   scanf("%d \"%[^\"]\"", &a->ra, buf);

   a->nome = malloc(strlen(buf)+1);
   strcpy(a->nome, buf);
   return;
}

void lelinha() {
   int c;
   do { c=getchar(); } while (c!='\n');
}

int main(int argc, char *argv[]) {
   /* ----------------------------------------------------------------------
      Declaraes e incio para verificao do uso da memria dinmica.
      ---------------------------------------------------------------------- */
   struct mallinfo info = mallinfo();
   int MemDinInicial = info.uordblks, MemDinFinal;
   /* ---------------------------------------------------------------------- */

   char fun[255]; scanf("%s", fun);
   if ( strcmp(fun,"Hash") == 0 ) {
      funcao_testada = f_Hash;
   } else if ( strcmp(fun,"CriaTabela") == 0 ) {
      funcao_testada = f_CriaTabela;
   } else if ( strcmp(fun,"InsereTabela") == 0 ) {
      funcao_testada = f_InsereTabela;
   } else if ( strcmp(fun,"RemoveTabela") == 0 ) {
      funcao_testada = f_RemoveTabela;
   } else if ( strcmp(fun,"ConsultaTabela") == 0 ) {
      funcao_testada = f_ConsultaTabela;
   } else if ( strcmp(fun,"NumeroAlunosTabela") == 0 ) {
      funcao_testada = f_NumeroAlunosTabela;
   } else if ( strcmp(fun,"ImprimeTabela") == 0 ) {
      funcao_testada = f_ImprimeTabela;
   } else if ( strcmp(fun,"LiberaTabela") == 0 ) {
      funcao_testada = f_LiberaTabela;
   } else {
      printf("Funo `%s a ser testada  desconhecida.\n", fun);
      return 2;
   }
   printf("Testando apenas a funo `%s.\n", fun);


   TabelaHash *t = CriaTabela();
   char comando[100], buf[TAMMAXNOME];
   Aluno a;
   

   while ( scanf("%s", comando) > 0 ) {
      if ( strcmp(comando,"insere") == 0 ) {

	 LeAluno(&a);
	 printf("Insere: %06d \"%s\"\n", a.ra, a.nome);
	 if (!InsereTabela(t, &a)) {
	    printf("Nome repetido: \"%s\"\n", a.nome);
	    free(a.nome);
	 }

      } else if ( strcmp(comando, "remove") == 0 ) {

	 scanf(" \"%[^\"]\"", buf);
	 printf("Remove: \"%s\"\n", buf);
	 if (!RemoveTabela(t, buf))
	    printf("Nome inexistente: \"%s\"\n", buf);

      } else if ( strcmp(comando, "consulta") == 0 ) {

	 scanf(" \"%[^\"]\"", buf);
	 printf("Consulta: \"%s\"\n", buf);
	 if (ConsultaTabela(t, buf, &a))
	    printf("%06d \"%s\"\n", a.ra, a.nome);
	 else
	    printf("Nome inexistente: \"%s\"\n", buf);

      } else if ( strcmp(comando, "imprime") == 0 ) {

	 printf("\nImprime Tabela: %d aluno(s):\n", NumeroAlunosTabela(t));
	 ImprimeTabela(t);
	 printf("\n");

      } else if ( strcmp(comando, "sair") == 0 ) {
	 break;
      } else {
	 printf("Comando desconhecido: `%s\n", comando);
      }
   }

   LiberaTabela(t);

   /* --------------------------------------------------------------------- */
   /* Verificao final do uso da memria dinmica                          */
   /* --------------------------------------------------------------------- */
   info = mallinfo();
   MemDinFinal = info.uordblks;
   if (MemDinInicial!=MemDinFinal)
      printf("\n\nMemria dinmica no foi totalmente liberada (%d, %d)\n",
	     MemDinInicial,MemDinFinal);
   /* --------------------------------------------------------------------- */
   return 0;
}
