/* MC202 - Estruturas de dados - 2. semestre de 2005.
 * Implementao de Heap para Dijkstra. */

#ifndef HEAP_H
#define HEAP_H

#define INFINITO 100000

typedef struct heap Heap;

/* Retorna um novo Heap vazio. 
 * dist  o vetor de distncias at o momento para cada vrtice v, ie,
 * dist[v] indica a distncia corrente para o vrtice v.
 */
Heap *cria_heap(int nvertices, int *dist);

/* Destri o heap passado como parmetro. */
void destroi_heap(Heap **heap);

/* Aplica a operao "sobe" para o vrtice `vert'*/
void sobe_heap(Heap *heap, int *dist, int vert);

/* Remove o menor elemento do heap, retornando o ndice do vrtice. */
int remove_menor_heap(Heap *heap, int *dist);

/* Retorna 1 se o vrtice v est no heap, 0 cc.*/
int esta_no_heap(Heap *heap, int v);

/* Retorna 1 se o heap est vazio, 0 cc. */
int heap_vazio(Heap *heap);

#endif
